/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "icmp.h"

//############################################################################
//Diese Routine erzeugt ein ICMP Packet
void ICMP_Reply (char *buffer,int bufferlen)
//############################################################################
{
	//Variablen zur Berechnung der Checksumme
	unsigned int result16;

	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];

	struct ICMP_Header *icmp;
	icmp = (struct ICMP_Header *)&buffer[ICMP_OFFSET];
	
	//Das ist ein Echo Reply Packet
	icmp->ICMP_Type = 0x00;
	icmp->ICMP_Code = 0x00;
	
	//Berechnung der ICMP Checksumme
	//Alle Daten im ICMP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	icmp->ICMP_Cksum = 0x0000;

	//Hier wird erstmal der IP Header neu erstellt
	Make_IP_Header (buffer);

	//Berechnung der ICMP Header lnge
	result16 = ((ip->IP_Pktlen & 0xFF00) >> 8)|((ip->IP_Pktlen & 0x00FF)<<8);
	result16 = result16 - ((ip->IP_Vers_Len & 0x0F) << 2);

	//pointer wird auf das erste Packet im ICMP Header gesetzt
	//jetzt wird die Checksumme berechnet
	result16 = checksum (&icmp->ICMP_Type, result16, 0);
	
	//schreibt Checksumme ins Packet
	icmp->ICMP_Cksum = ((result16 & 0xFF00) >> 8)|((result16 & 0x00FF)<<8);
	
	//Sendet das erzeugte ICMP Packet 
	Write_Ethernet_Frame (buffer,bufferlen);
}
