/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "clock.h"

#if USE_TELNET
PROGMEM char telnet_OK[] = {"\0%END"};
PROGMEM char telnet_newline[] = {">%END"};
PROGMEM char telnet_end[] = {"Good Bye!\r\n%END"};
PROGMEM char telnet_welcome[] = {"Willkommen auf dem Telnetserver\r\n>%END"};
unsigned char cmd[CMDBUFFER];
unsigned char cmd_Counter = 0;

//############################################################################
//
void telnet (char* buffer,int *bufferlen)
//############################################################################
{	
	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack (buffer,bufferlen,&a)== 1)
		{
		return;//keine Daten fr Anwendung
		}
	
	tcp_socket= &tcpsockets[a]; //Pointer auf tcpsockets[a] holen

	//Antwort Telnet Server Vorhanden 
	if ((buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN1)
			{
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//Telnet Server Antwort Packet
			tcp_add_data (telnet_welcome,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			tcp_socket->Status = TCP_SOCKET_OPEN2;
			return;
			}
			
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && tcp_socket->Status == TCP_SOCKET_OPEN2)
	{
		unsigned int result16;
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);	
		//Errechnet startpunkt der Daten im Tcp buffer
		//IP Headerlnge + TCP Headerlnge + Ethernetframe
		result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
					((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;		
		//Ausgabe des empfangenen Zeichens
		cmd[cmd_Counter] = buffer[result16];
		cmd_Counter++;
		if (buffer[result16]==0x0d)
			{
			cmd_Counter--;
			cmd[cmd_Counter] = '\0';
			cmd_Counter = 0;				
				#if USE_CLOCK
					//Commando zur Ausgabe/Setzen der Zeit
					if ( memcmp(&cmd[0],"time",4) == 0)
						{	
						char string[40]= {"Time: "};
						char tmp[5];
						//Commando setzen der Zeit
						if ( memcmp(&cmd[0],"time -s",7) == 0)
							{		
							//auslesen der Stunden aus String
							tmp[0] = cmd[8];
							tmp[1] = cmd[9];
							tmp[2] = 0;
							hh = (atoi(tmp) & 0x00FF);
							//auslesen der Minuten aus String
							tmp[0] = cmd[11];
							tmp[1] = cmd[12];
							tmp[2] = 0;
							mm = (atoi(tmp) & 0x00FF);
							//auslesen der Sekunden aus String
							tmp[0] = cmd[14];
							tmp[1] = cmd[15];
							tmp[2] = 0;
							ss = (atoi(tmp) & 0x00FF);
							}	
						strcat (string,itoa(hh,tmp,10));
						strcat (string,":");
						strcat (string,itoa(mm,tmp,10));
						strcat (string,":");
						strcat (string,itoa(ss,tmp,10));
									
						strcat (string,"\r\n>");
						tcp_add_datastring (string,buffer,bufferlen);
						
						goto telnet_end;
						}		
				#endif //USE_CLOCK
				
				#if USE_MMC
					if ( memcmp(&cmd[0],"dir",3) == 0)
						{
						unsigned int tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
							((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;	
						unsigned char Dir_Attrib;
						Read_Dir_Ent (0,0,&tcp_socket->File_Size,&Dir_Attrib,&buffer[tcpdata]); 
						
						if( Read_Dir_Ent (tcp_socket->Cluster,tcp_socket->File_Block_Counter,
											&tcp_socket->File_Size,&Dir_Attrib,&buffer[tcpdata]) == 0xffff)
							{
							tcp_socket->File_Block_Counter = 0;
							buffer[tcpdata] = '\0';
							strcat (&buffer[tcpdata],">");
							}
						else
							{
							strcat (&buffer[tcpdata],"\r\n");
							tcp_socket->File_Block_Counter++;
							}
						tcp_add_datastring (&buffer[tcpdata],buffer,bufferlen);
						goto telnet_end;
						}
					if ( memcmp(&cmd[0],"cd",2) == 0)
						{
						unsigned int tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
										((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;	
						unsigned char Dir_Attrib;
						
						if (Search_File(&cmd[3],&tcp_socket->Cluster,
										 &tcp_socket->File_Size,
										 &Dir_Attrib,
										 &buffer[tcpdata]) == 1 && Dir_Attrib == 0x10)
							{
							tcp_add_datastring ("OK\r\n>",buffer,bufferlen);
							tcp_socket->File_Block_Counter = 0;
							}
						else
							{
							tcp_add_datastring ("Dir not Found\r\n>",buffer,bufferlen);
							tcp_socket->Cluster = 0;
							tcp_socket->File_Block_Counter = 0;
							}
						goto telnet_end;
						}
				#endif //USE_MMC
				
				//Telnet Verbindung schlieen
				if (memcmp(&cmd[0],"quit",4) == 0)
					{
					tcp_add_data (telnet_end,buffer,bufferlen);
					tcp_socket->Status = TCP_SOCKET_CLOSE;
					goto telnet_end;
					}
				tcp_add_data (telnet_newline,buffer,bufferlen);
				goto telnet_end;
			};			
			tcp_add_data (telnet_OK,buffer,bufferlen);
				
			telnet_end:
			buffer[TCP_HDRFLAGS+1] = PSH_FLAG | ACK_FLAG;
			//Erzeugt ein TCP buffer 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP buffer 
			Write_Ethernet_Frame (buffer,*bufferlen);
			return;
	}
	
	#if USE_MMC
	if ((	buffer[TCP_HDRFLAGS+1]&ACK_FLAG) > 0 	&& 
			tcp_socket->Status == TCP_SOCKET_OPEN2	&&
			tcp_socket->File_Block_Counter > 0)
			{
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);	
			
			unsigned int tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + 
										((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;	
			unsigned char Dir_Attrib;
			if( Read_Dir_Ent (tcp_socket->Cluster,tcp_socket->File_Block_Counter,
								&tcp_socket->File_Size,&Dir_Attrib,&buffer[tcpdata]) == 0xffff)
				{
				tcp_socket->File_Block_Counter = 0;
				buffer[tcpdata] = '\0';
				strcat (&buffer[tcpdata],">");
				}
				else
				{
				strcat (&buffer[tcpdata],"\r\n");
				tcp_socket->File_Block_Counter++;
				}
			tcp_add_datastring (&buffer[tcpdata],buffer,bufferlen);	
			buffer[TCP_HDRFLAGS+1] = PSH_FLAG | ACK_FLAG;
			//Erzeugt ein TCP buffer 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP buffer 
			Write_Ethernet_Frame (buffer,*bufferlen);
			}
	#endif //USE_MMC
	return;
}
#endif //USE_TELENET

